<template>
  <v-main class="app">
    <piece-loader
      :client="client"
      :piece-path="piecePath"
      app-name="collabscore"
      @update:piece="onPieceLoad"
    />
    <!-- The main dezrann component -->
    <!-- Receives a piece and analysis, and handles display and editing -->
    <analysis-editor
      v-if="piece"
      :piece="piece"
      :analysis="null"
      :scroll.sync="scroll"
      :visible-analysis="false"
      :editable-analysis="false"
    />
    <!-- Renders analysis control buttons on the sidebar -->
    <portal to="sidebar-buttons">
      <v-list v-if="piece" nav dense>
        <sidebar-button
          :url="`${refsBase['collabscore'].baseUrl}`.replace('$', piece.refs.collabscore)"
          icon="mdi-file-music"
        >
          {{ $t('button.link-see-neuma') }}
        </sidebar-button>
        <sidebar-button
          :url="`${refsBase['gallica'].baseUrl}`.replace('$', piece.refs.gallica)"
          icon="mdi-script-text"
        >
          {{ $t('button.link-see-gallica') }}
        </sidebar-button>
        <sidebar-button :url="`${$route.fullPath}`.replace('collabscore', '~')" icon="mdi-marker">
          {{ $t('button.link-analyze-dezrann') }}
        </sidebar-button>
      </v-list>
    </portal>

    <title-manager
      v-if="!hideTitle && !loading"
      :index-current-piece="indexCurrentPiece"
      :corpus="corpus"
      app-name="collabscore"
    />
    <scroll-query-manager
      v-if="piece"
      :scroll.sync="scroll"
      :signature="piece.signature"
    />
  </v-main>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import TitleManager from '@/components/navigation/TitleManager.vue';
import PieceLoader from '@/vuejs/components/loaders/PieceLoader.vue';
import ScrollQueryManager from '@/components/navigation/ScrollQueryManager.vue';
import { REFS_BASE } from '@/components/navigation/RefsBase';
import type {
  Onset,
  Piece,
} from '@/data';

import type { Client } from '@/client';
import {
  getClient, getCorpus, getIndexPieceAlt, getPiecePath, removeLast, sortCorpus,
} from '@/vuejs/components/utils/nav-tools';
import SidebarButton from '@/vuejs/components/navigation/buttons/SidebarButton.vue';
import AnalysisEditor from '@/components/AnalysisEditor.vue';

/**
 * The main dezrann integration
 * loads piece and analysis for the CollabscoreView
 * then displays a piece analysis and lets a user modify it
 */
@Component({
  components: {
    AnalysisEditor,
    PieceLoader,
    ScrollQueryManager,
    TitleManager,
    SidebarButton,
  },
})
export default class CollabscorePage extends Vue {
  allowSync = !!process.env.VUE_APP_ALLOW_SYNC;

  piece: Piece | null = null;

  corpus: Piece[] = this.$store.state.corpus;

  indexCurrentPiece = this.$store.state.indexCurrentPiece;

  loading = true;

  refsBase: Record<string, Record<string, string>> = REFS_BASE;

  /** The current piece path, to load the piece from the client */
  get piecePath(): string { return getPiecePath(this.$route); }

  /** The current client for this route */
  get client(): Client { return getClient(this.$route); }

  get hideTitle(): boolean {
    return 'secret' in this.$route.query;
  }

  async onPieceLoad(piece: Piece) {
    this.piece = piece;

    if (removeLast(piece.path, '/') !== this.$store.state.corpusId) await this.updateCorpus();
    this.indexCurrentPiece = getIndexPieceAlt(piece, this.corpus);
    this.$store.dispatch('updateIndexCurrentPiece', { indexCurrentPiece: this.indexCurrentPiece });
    this.loading = false;
  }

  async updateCorpus() {
    const corpora = await this.client.loadCorpus();
    this.corpus = sortCorpus(await getCorpus(this.piece as Piece, corpora.data));
    this.$store.dispatch('updateCorpus', {
      corpus: this.corpus,
      corpusId: removeLast((this.piece as Piece).path, '/'),
    });
  }

  /**
   * The current scroll of the editor
   */
  scroll: Onset | null = null;
}
</script>
